----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:38:31 03/04/2008 
-- Design Name: 
-- Module Name:    seconds_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ten_counter is
    Port ( clk : in  STD_LOGIC;
		     ce : in STD_LOGIC;
           rst : in  STD_LOGIC;  --active low
           dout : out  STD_LOGIC_VECTOR (3 downto 0);
           co : out  STD_LOGIC);
end ten_counter;

architecture Behavioral of ten_counter is

signal count : std_logic_vector (3 downto 0) := "0000";
signal carryout : std_logic := '0';

begin

process (clk, rst, ce, count, carryout)
begin
if (rst='0') then
  count <= (others=>'0');
  carryout <= '0';
  elsif (ce='1' and clk'event and clk='1') then
     if (count="1000") then
	     count <= count +1;
		  carryout <= '1'; -- count goes to 9, and set the co for the tens digit
	  elsif (count = "1001") then --if count=9, then roll-over to 0
			  count <= (others=>'0');
			  carryout <= '0';
		  else 
			count <= count+1;
			carryout <= '0';
		  end if;
end if;
end process;

co <= carryout;  
dout <= count;

end Behavioral;

